import { defineComponent as S, ref as y, onMounted as L, markRaw as T, watch as x, unref as v, openBlock as b, createElementBlock as E, computed as I, nextTick as G, shallowRef as Z, getCurrentInstance as q, onBeforeUnmount as K, normalizeClass as Q, normalizeStyle as X, createBlock as Y, resolveDynamicComponent as ee, mergeProps as te } from "vue";
import "codemirror/lib/codemirror.css";
import R from "codemirror";
import "codemirror/addon/merge/merge.css";
import "codemirror/addon/merge/merge.js";
import ne from "diff-match-patch";
import "codemirror/addon/mode/simple.js";
!window.CodeMirror && (window.CodeMirror = R);
const _ = window.CodeMirror || R, oe = S({
  name: "DefaultMode",
  props: {
    name: {
      type: String,
      default: `cm-textarea-${+new Date()}`
    },
    value: {
      type: String,
      default: ""
    },
    content: {
      type: String,
      default: ""
    },
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => null
    },
    placeholder: {
      type: String,
      default: ""
    }
  },
  emits: {
    ready: (e) => e,
    "update:cminstance": (e) => e
  },
  setup(e, { emit: o }) {
    const r = y(), t = y(null), n = () => {
      t.value = T(
        _.fromTextArea(r.value, e.options)
      ), o("update:cminstance", t.value);
      const i = x(
        () => e.cminstance,
        (s) => {
          var f;
          s && ((f = e.cminstance) == null || f.setValue(e.value || e.content)), o("ready", v(t)), i == null || i();
        },
        { deep: !0 }
      );
    };
    return L(() => {
      n();
    }), {
      textarea: r,
      initialize: n
    };
  }
}), A = (e, o) => {
  const r = e.__vccOpts || e;
  for (const [t, n] of o)
    r[t] = n;
  return r;
}, re = ["name", "placeholder"];
function ae(e, o, r, t, n, i) {
  return b(), E("textarea", {
    ref: "textarea",
    name: e.$props.name,
    placeholder: e.$props.placeholder
  }, null, 8, re);
}
const F = /* @__PURE__ */ A(oe, [["render", ae]]);
window.diff_match_patch = ne;
window.DIFF_DELETE = -1;
window.DIFF_INSERT = 1;
window.DIFF_EQUAL = 0;
const se = S({
  name: "MergeMode",
  props: {
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => ({})
    }
  },
  emits: ["update:cminstance", "ready"],
  setup(e, { emit: o }) {
    const r = y(), t = y(), n = () => {
      r.value = T(
        _.MergeView(t.value, e.options)
      ), o("update:cminstance", r.value), o("ready", r);
    };
    return L(() => {
      n();
    }), {
      mergeView: t,
      initialize: n
    };
  }
}), le = { ref: "mergeView" };
function ce(e, o, r, t, n, i) {
  return b(), E("div", le, null, 512);
}
const ie = /* @__PURE__ */ A(se, [["render", ce]]);
var ue = /* @__PURE__ */ ((e) => (e.info = "info", e.warning = "warning", e.error = "error", e))(ue || {});
function de() {
  const e = new Date(), o = e.getHours() < 10 ? `0${e.getHours()}` : e.getHours(), r = e.getMinutes() < 10 ? `0${e.getMinutes()}` : e.getMinutes(), t = e.getSeconds() < 10 ? `0${e.getSeconds()}` : e.getSeconds();
  return `${o}:${r}:${t}`;
}
function Te(e) {
  return `#link#${JSON.stringify(e)}#link#`;
}
function pe(e) {
  const o = /#link#(.+)#link#/g, r = [];
  let t;
  for (t = o.exec(e); t; ) {
    const n = document.createElement("a"), i = JSON.parse(t[1]), s = Object.entries(i);
    for (const [f, u] of s)
      n.setAttribute(f, u);
    n.className = "editor_custom_link", n.innerHTML = "logDownload", r.push({
      start: t.index,
      end: t.index + t[0].length,
      node: n
    }), t = o.exec(e);
  }
  return r;
}
function Ie(e = "", o = "info") {
  return `#log<${o}>log#${e}#log<${o}>log#`;
}
function ge(e) {
  const o = [];
  function r() {
    const t = /#log<(\w*)>log#((.|\r\n|\n)*?)#log<(\w*)>log#/g;
    let n;
    for (n = t.exec(e); n; ) {
      const s = n[0].replace(/\r\n/g, `
`).split(`
`), u = n[2].replace(/\r\n/g, `
`).split(`
`), m = document.createElement("span"), c = n[1];
      m.className = `c-editor--log__${c}`;
      let d = 0;
      for (let l = 0; l < s.length; l++) {
        const p = s[l], k = u[l], w = m.cloneNode(!1);
        w.innerText = k, o.push({
          start: n.index + d,
          end: n.index + d + p.length,
          node: w
        }), d = d + p.length + 1;
      }
      n = t.exec(e);
    }
  }
  return r(), o;
}
function Ae(e, o) {
  return `[${de()}] <${o}> ${e}`;
}
function De(e, o, r) {
  const n = new Array(Math.max(o || 15, 5)).join(r || "=");
  return `${n}${e}${n}`;
}
const M = [
  {
    regex: /(\[.*?\])([ \t]*)(<error>[ \t])(.+)/,
    token: ["tag", "", "error.strong", "error.strong"],
    sol: !0
    // next: "error",
  },
  {
    regex: /(\[.*?\])([ \t]*)(<info>)(.+)(.?)/,
    token: ["tag", "", "bracket", "bracket", "hr"],
    sol: !0
    // next: "info",
  },
  {
    regex: /(\[.*?\])([ \t]*)(<warning>)(.+)(.?)/,
    token: ["tag", "", "comment", "comment", "hr"],
    sol: !0
    // next: "warning",
  }
];
_.defineSimpleMode("fclog", {
  start: [
    ...M,
    {
      regex: /.*/,
      token: "hr"
    }
  ],
  error: [
    ...M,
    {
      regex: /.*/,
      token: "error.strong"
    }
  ],
  info: [
    ...M,
    {
      regex: /.*/,
      token: "bracket"
    }
  ],
  warning: [
    ...M,
    {
      regex: /.*\[/,
      token: "comment"
    }
  ]
});
_.defineSimpleMode("log", {
  start: [
    {
      regex: /^[=]+[^=]*[=]+/,
      token: "strong"
    },
    {
      regex: /([^\w])([A-Z][\w]*)/,
      token: ["", "string"]
    },
    {
      regex: /(^[A-Z][\w]*)/,
      token: "string"
    }
    // {
    //     regex: /([^\d])([0-9]+)/,
    //     token: [null, 'comment']
    // },
    // {
    //     regex: /(^[0-9]+)/,
    //     token: 'comment'
    // }
  ]
});
const me = S({
  name: "CodemirrorFclog",
  props: {
    value: {
      type: String,
      default: ""
    },
    name: {
      type: String,
      default: `cm-textarea-${+new Date()}`
    },
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => ({})
    },
    placeholder: {
      type: String,
      default: ""
    }
  },
  emits: ["update:cminstance", "ready"],
  setup(e, { emit: o }) {
    const r = y(), t = y(null), n = (s = e.cminstance) => {
      s.getAllMarks().forEach((c) => c.clear());
      const u = s.getValue(), m = [].concat(pe(u)).concat(ge(u));
      for (let c = 0; c < m.length; c++) {
        const d = m[c];
        s.markText(
          s.posFromIndex(d.start),
          s.posFromIndex(d.end),
          { replacedWith: d.node }
        );
      }
    }, i = () => {
      var s;
      t.value = T(
        _.fromTextArea(r.value, e.options)
      ), o("update:cminstance", v(t)), (s = t.value) == null || s.on("change", n);
    };
    return x(
      () => e.cminstance,
      (s) => {
        var f;
        s && (n(e.cminstance), (f = e.cminstance) == null || f.setValue(e.value), o("ready", t));
      },
      { deep: !0, immediate: !0 }
    ), L(() => {
      i();
    }), {
      initialize: i,
      textarea: r
    };
  }
}), fe = ["name", "placeholder"];
function he(e, o, r, t, n, i) {
  return b(), E("textarea", {
    ref: "textarea",
    name: e.$props.name,
    placeholder: e.$props.placeholder
  }, null, 8, fe);
}
const ve = /* @__PURE__ */ A(me, [["render", he]]), z = {
  "update:value": () => !0,
  change: (e, o) => ({ value: e, cm: o }),
  input: () => !0,
  ready: (e) => e
}, ye = [
  "changes",
  "scroll",
  "beforeChange",
  "cursorActivity",
  "keyHandled",
  "inputRead",
  "electricInput",
  "beforeSelectionChange",
  "viewportChange",
  "swapDoc",
  "gutterClick",
  "gutterContextMenu",
  "focus",
  "blur",
  "refresh",
  "optionChange",
  "scrollCursorIntoView",
  "update"
], we = () => {
  const e = {};
  return ye.forEach((o) => {
    e[o] = (...r) => r;
  }), e;
}, ke = { ...z, ...we() }, j = {
  mode: "text",
  // Language mode
  theme: "default",
  // Theme
  lineNumbers: !0,
  // Display line number
  smartIndent: !0,
  // Intelligent indentation
  indentUnit: 2
};
function $e(e) {
  Promise.resolve().then(() => {
    const o = e.getScrollInfo();
    e.scrollTo(o.left, o.height);
  });
}
const xe = ({
  props: e,
  cminstance: o,
  emit: r,
  internalInstance: t,
  content: n
}) => {
  const i = I(
    () => {
      var u;
      return e.merge ? (u = v(o)) == null ? void 0 : u.editor() : v(o);
    }
  ), s = () => {
    const u = [];
    return Object.keys(t == null ? void 0 : t.vnode.props).forEach((m) => {
      if (m.startsWith("on")) {
        const c = m.replace(m[2], m[2].toLowerCase()).slice(2);
        !z[c] && u.push(c);
      }
    }), u;
  };
  return {
    listenerEvents: () => {
      i.value.on("change", (c) => {
        const d = c.getValue();
        d === n.value && d !== "" || (n.value = d, r("update:value", n.value || ""), r("input", n.value || " "), Promise.resolve().then(() => {
          r("change", n.value, c);
        }), e.keepCursorInEnd && $e(c));
      });
      const u = {};
      s().filter((c) => !u[c] && (u[c] = !0)).forEach((c) => {
        i.value.on(c, (...d) => {
          r(c, ...d);
        });
      });
    }
  };
};
function _e({
  props: e,
  cminstance: o,
  presetRef: r
}) {
  const t = y(null), n = y(null), i = I(
    () => {
      var l;
      return e.merge ? (l = v(o)) == null ? void 0 : l.editor() : v(o);
    }
  ), s = () => {
    G(() => {
      var l;
      (l = i.value) == null || l.refresh();
    });
  }, f = (l = e.width, p = e.height) => {
    var w;
    t.value = String(l).replace("px", ""), n.value = String(p).replace("px", "");
    const k = n.value;
    (w = i.value) == null || w.setSize(t.value, k);
  }, u = () => {
    var p;
    const l = (p = i.value) == null ? void 0 : p.getWrapperElement();
    l == null || l.remove();
  }, m = () => {
    var p, k, w;
    const l = (p = i.value) == null ? void 0 : p.getDoc().getHistory();
    (k = r.value) == null || k.initialize(), u(), (w = i.value) == null || w.getDoc().setHistory(l);
  }, c = () => {
    const l = document.querySelector(
      ".CodeMirror-gutters"
    );
    return (l == null ? void 0 : l.style.left.replace("px", "")) !== "0";
  };
  return {
    reload: m,
    refresh: s,
    resize: f,
    destroy: u,
    containerHeight: n,
    reviseStyle: () => {
      if (s(), !c())
        return;
      const l = setInterval(() => {
        c() ? s() : clearInterval(l);
      }, 60), p = setTimeout(() => {
        clearInterval(l), clearTimeout(p);
      }, 400);
    }
  };
}
const H = /* @__PURE__ */ S({
  __name: "index",
  props: {
    value: {
      type: String,
      default: ""
    },
    options: {
      type: Object,
      default: () => j
    },
    globalOptions: {
      type: Object,
      default: () => j
    },
    placeholder: {
      type: String,
      default: ""
    },
    border: {
      type: Boolean,
      default: !1
    },
    width: {
      type: [String, Number],
      default: null
    },
    height: {
      type: [String, Number],
      default: null
    },
    originalStyle: {
      type: Boolean,
      default: !1
    },
    keepCursorInEnd: {
      type: Boolean,
      default: !1
    },
    merge: {
      type: Boolean,
      default: !1
    },
    name: {
      type: String,
      default: ""
    },
    marker: {
      type: Function,
      default: () => null
    },
    unseenLines: {
      type: Array,
      default: () => []
    }
  },
  emits: ke,
  setup(e, { expose: o, emit: r }) {
    var N, V;
    const t = e;
    typeof Object.assign != "function" && Object.defineProperty(Object, "assign", {
      value(a, g) {
        if (a == null)
          throw new TypeError("Cannot convert undefined or null to object");
        const h = Object(a);
        for (let $ = 1; $ < arguments.length; $++) {
          const C = arguments[$];
          if (C != null)
            for (const O in C)
              Object.prototype.hasOwnProperty.call(C, O) && (h[O] = C[O]);
        }
        return h;
      },
      writable: !0,
      configurable: !0
    });
    const n = y(null), i = y(""), s = Z(F), f = y({
      ...j,
      ...t.globalOptions,
      ...t.options
    }), u = q(), m = t.name || ((V = (N = u == null ? void 0 : u.parent) == null ? void 0 : N.type) == null ? void 0 : V.name) || void 0, c = y(null), d = I(
      () => {
        var a;
        return t.merge ? (a = v(n)) == null ? void 0 : a.editor() : v(n);
      }
    ), { refresh: l, resize: p, destroy: k, containerHeight: w, reviseStyle: B } = _e({
      props: t,
      cminstance: n,
      presetRef: c
    }), { listenerEvents: P } = xe({
      props: t,
      cminstance: n,
      emit: r,
      internalInstance: u,
      content: i
    }), D = () => {
      t.unseenLines !== void 0 && t.marker !== void 0 && t.unseenLines.forEach((a) => {
        var h, $;
        const g = (h = n.value) == null ? void 0 : h.lineInfo(a);
        ($ = n.value) == null || $.setGutterMarker(
          a,
          "breakpoints",
          g != null && g.gutterMarkers ? null : t.marker()
        );
      });
    }, U = (a) => {
      var h, $;
      const g = (h = n.value) == null ? void 0 : h.getValue();
      a !== g && (($ = n.value) == null || $.setValue(a), i.value = a, B()), D();
    }, W = () => {
      P(), D(), p(t.width, t.height), r("ready", n.value), x(
        [() => t.width, () => t.height],
        ([a, g]) => {
          p(a, g);
        },
        { deep: !0 }
      );
    }, J = () => {
      if (t.options.mode === "fclog" || t.options.mode === "log") {
        s.value = ve;
        return;
      }
      if (t.merge) {
        s.value = ie;
        return;
      }
      s.value = F;
    };
    return x(
      () => t.options,
      (a) => {
        var g;
        for (const h in t.options)
          (g = d.value) == null || g.setOption(
            h,
            v(a[h])
          );
      },
      { deep: !0 }
    ), x(
      () => t.value,
      (a) => {
        U(a);
      }
    ), x(
      () => t.placeholder,
      (a) => {
        var g;
        (g = d.value) == null || g.setOption("placeholder", a);
      }
    ), x(
      () => t.merge,
      (a) => {
        J();
      },
      { immediate: !0 }
    ), K(() => {
      k();
    }), o({
      cminstance: n,
      resize: p,
      refresh: l,
      destroy: k
    }), (a, g) => (b(), E("div", {
      class: Q(["codemirror-container", {
        merge: a.$props.merge,
        bordered: a.$props.border || a.$props.merge && !t.originalStyle,
        "width-auto": !a.$props.width || a.$props.width == "100%",
        "height-auto": !a.$props.height || a.$props.height == "100%",
        "original-style": t.originalStyle
      }]),
      style: X({
        height: v(w) + "px"
      })
    }, [
      (b(), Y(ee(v(s)), te({
        ref_key: "presetRef",
        ref: c,
        cminstance: n.value,
        "onUpdate:cminstance": g[0] || (g[0] = (h) => n.value = h),
        style: { height: "100%" }
      }, {
        ...a.$props,
        ...a.$attrs,
        options: f.value,
        name: v(m),
        content: i.value
      }, { onReady: W }), null, 16, ["cminstance"]))
    ], 6));
  }
});
const be = (e, o) => (o && o.options && (H.props.globalOptions.default = () => o.options), e.component((o == null ? void 0 : o.componentName) || "Codemirror", H), e), Ne = window.CodeMirror || _, Ve = be;
function styleInject(css,ref){if(ref===void 0){ref={}}var insertAt=ref.insertAt;if(!css||typeof document==="undefined"){return}var head=document.head||document.getElementsByTagName("head")[0];var style=document.createElement("style");style.type="text/css";if(insertAt==="top"){if(head.firstChild){head.insertBefore(style,head.firstChild)}else{head.appendChild(style)}}else{head.appendChild(style)}if(style.styleSheet){style.styleSheet.cssText=css}else{style.appendChild(document.createTextNode(css))}};styleInject(`.codemirror-container {
  position: relative;
  display: inline-block;
  height: 100%;
  width: fit-content;
  font-size: 12px;
  overflow: hidden;
}
.codemirror-container.bordered {
  border-radius: 4px;
  border: 1px solid #dddddd;
}
.codemirror-container.width-auto {
  width: 100%;
}
.codemirror-container.height-auto {
  height: 100%;
}
.codemirror-container.height-auto .CodeMirror,
.codemirror-container.height-auto .cm-s-default {
  height: 100% !important;
}
.codemirror-container .editor_custom_link {
  cursor: pointer;
  color: #1474f1;
  text-decoration: underline;
}
.codemirror-container .editor_custom_link:hover {
  color: #04b4fa;
}
.codemirror-container:not(.original-style) .CodeMirror-lines .CodeMirror-placeholder.CodeMirror-line-like {
  color: #666;
}
.codemirror-container:not(.original-style) .CodeMirror,
.codemirror-container:not(.original-style) .CodeMirror-merge-pane {
  height: 100%;
  font-family: consolas !important;
}
.codemirror-container:not(.original-style) .CodeMirror-merge,
.codemirror-container:not(.original-style) .CodeMirror-merge-right .CodeMirror {
  height: 100%;
  border: none !important;
}
.codemirror-container:not(.original-style) .c-editor--log__error {
  color: #bb0606;
  font-weight: bold;
}
.codemirror-container:not(.original-style) .c-editor--log__info {
  color: #333333;
  font-weight: bold;
}
.codemirror-container:not(.original-style) .c-editor--log__warning {
  color: #ee9900;
}
.codemirror-container:not(.original-style) .c-editor--log__success {
  color: #669600;
}
.codemirror-container:not(.original-style) .cm-header,
.codemirror-container:not(.original-style) .cm-strong {
  font-weight: bold;
}
`);
export {
  Ne as CodeMirror,
  Ve as GlobalCmComponent,
  H as VueCodemirror,
  Te as createLinkMark,
  Ae as createLog,
  Ie as createLogMark,
  De as createTitle,
  H as default,
  pe as getLinkMarks,
  de as getLocalTime,
  ge as getLogMark,
  ue as logErrorType
};
